'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withToastUtils = exports.Toasts = exports.ToastProvider = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styled = require('./styled');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _React$createContext = _react2.default.createContext(),
    Consumer = _React$createContext.Consumer,
    Provider = _React$createContext.Provider;

// Generate a unique enough ID


function generateUEID() {
  var first = Math.random() * 46656 | 0;
  var second = Math.random() * 46656 | 0;
  first = ('000' + first.toString(36)).slice(-3);
  second = ('000' + second.toString(36)).slice(-3);
  return first + second;
}

// Provider
// ==============================

var ToastProvider = exports.ToastProvider = function (_Component) {
  _inherits(ToastProvider, _Component);

  function ToastProvider() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ToastProvider);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ToastProvider.__proto__ || Object.getPrototypeOf(ToastProvider)).call.apply(_ref, [this].concat(args))), _this), _this.state = { toasts: [] }, _this.addToast = function (content) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      return function () {
        var toasts = _this.state.toasts.slice(0);
        var id = generateUEID();

        // spreading options allows consumers to provide their own ID, so they
        // can remove the toast programatically if they want to
        toasts.push(_extends({ content: content, id: id }, options));

        _this.setState({ toasts: toasts });
      };
    }, _this.removeToast = function (id) {
      return function () {
        var toasts = _this.state.toasts.filter(function (t) {
          return t.id !== id;
        });
        _this.setState({ toasts: toasts });
      };
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ToastProvider, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var toasts = this.state.toasts;
      var addToast = this.addToast,
          removeToast = this.removeToast;


      return _react2.default.createElement(
        Provider,
        { value: { addToast: addToast, removeToast: removeToast } },
        this.props.children,
        _react2.default.createElement(
          _styled.ToastContainer,
          null,
          toasts.map(function (_ref2) {
            var content = _ref2.content,
                id = _ref2.id,
                rest = _objectWithoutProperties(_ref2, ['content', 'id']);

            return _react2.default.createElement(
              _styled.Toast,
              _extends({ key: id, onDismiss: _this2.removeToast(id) }, rest),
              content
            );
          })
        )
      );
    }
  }]);

  return ToastProvider;
}(_react.Component);

var Toasts = exports.Toasts = function Toasts(_ref3) {
  var children = _ref3.children;
  return _react2.default.createElement(
    Consumer,
    null,
    function (context) {
      return children(context);
    }
  );
};

var withToastUtils = exports.withToastUtils = function withToastUtils(Comp) {
  return function (props) {
    return _react2.default.createElement(
      Toasts,
      null,
      function (context) {
        return _react2.default.createElement(Comp, _extends({ toast: context }, props));
      }
    );
  };
};